#ifndef LIB_DBG_DEBUG_STDLIB_MQL5_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_STDLIB_MQL5_TRACER_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the debugger library include file.
 *
 * This file may be copied and/or distributed at free will.
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI standard library compatibility module for MQLAPI tracer
//


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 API function call meta object
//

#ifndef __MQL4__
	namespace dbg_lib
	{

#endif


    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //
    // Global standard library injection object template
    //    
    
    template <typename MQL5_STDLIB, typename DBG_STDLIB>
    class stdlib_call_tracer_mql5 : public LIB_DBG_NAMESPACE(dbg_lib, mqlapi_call_tracer_object_mql5)<MQL5_STDLIB>
    {
        public:
        // Function router
    
            DBG_STDLIB* dbg_mql_api_call_tracer;
    
    
        // Constructor
    
            stdlib_call_tracer_mql5(DBG_STDLIB* p_this) :
                dbg_mql_api_call_tracer(p_this)
            {};
    
    
        // Debug location recorder
    
            DBG_STDLIB* trace_call_details(const int _line_in, const char _func_id, const string _file_in, const string _function_in, const string _mqlapi_func, const string _api_name = NULL)
            {
    /*
                // Prestate setup
                _params_out         = NULL;
                _params_in          = NULL;
                _api_name_          = (_api_name_ == NULL) ? _api_name : _api_name_;
                _print_params_      = LIB_MQLAPI_TRACE_SHOW_PARAMS;
                _print_result_      = LIB_MQLAPI_TRACE_SHOW_RESULT;
                _perf_runtime_      = NULL;
                _prev_err_state     = _LastError;
    
                // Trace setup details
                _line               = _line_in;
                _rtol_op            = _func_id;
                _file               = _file_in;
                _function           = _function_in;
                _mqlapi_funcname    = _mqlapi_func;
    */
                // Return
                return(dbg_mql_api_call_tracer);
            }
    };
    
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //
    // Specific standard library injection objects
    //    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CCHART
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_Chart_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Chart_mql5<MQL5_STDLIB>> 
        {
            public:
            // Constructor
        
                stdlib_call_tracer_Chart_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Chart_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function wrappers
        
            #ifdef Symbol
                #undef Symbol
                #define MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef Period
                #undef Period
                #define MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
                string              __Symbol() const                                                { return(this.Symbol()); }
                ENUM_TIMEFRAMES     __Period() const                                                { return(this.Period()); }
        
            
            #ifdef MQLAPI_TRACE_REDEFINE_Symbol
                #define Symbol DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol, 0)
                #undef MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Period
                #define Period DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period, 0)
                #undef MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
            // Function routers
        
                string              dbg_mqlapi_trace_func_Symbol(void) const                        { return(__Symbol()); }
                ENUM_TIMEFRAMES     dbg_mqlapi_trace_func_Period(void) const                        { return(__Period()); }
        };

    #endif
    

    #ifdef LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_ChartObject_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_ChartObject_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_ChartObject_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_ChartObject_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function wrappers
        
            #ifdef Symbol
                #undef Symbol
                #define MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef Period
                #undef Period
                #define MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
                string              __Symbol() const                                                { return(this.Symbol()); }
                bool                __Symbol(const string symbol) const                             { return(this.Symbol(symbol)); }
                int                 __Period() const                                                { return(this.Period()); }
                bool                __Period(const int period) const                                { return(this.Period(period)); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Symbol
                #define Symbol DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol, 0)
                #undef MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Period
                #define Period DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period, 0)
                #undef MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
            // Function routers
        
                string              dbg_mqlapi_trace_func_Symbol(void) const                        { return(__Symbol()); }
                bool                dbg_mqlapi_trace_func_Symbol(const string symbol) const         { return(__Symbol(symbol)); }
                int                 dbg_mqlapi_trace_func_Period(void) const                        { return(__Period()); }
                bool                dbg_mqlapi_trace_func_Period(const int period) const            { return(__Period(period)); }
        };

    #endif


    #ifdef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_TrailingMA_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_TrailingMA_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_TrailingMA_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_TrailingMA_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef Period
                #undef Period
                #define MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
                void                __Period(int period)                                            { return(this.Period(period)); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Period
                #define Period DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period, 0)
                #undef MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
            // Function routers
        
                void                dbg_mqlapi_trace_func_Period(int period)                        { __Period(period); }
        };
    
    
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_ExpertBase_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_ExpertBase_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_ExpertBase_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_ExpertBase_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef Symbol
                #undef Symbol
                #define MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef Period
                #undef Period
                #define MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
                bool                __Symbol(string symbol)                                         { return(this.Symbol(symbol)); }
                bool                __Period(ENUM_TIMEFRAMES value)                                 { return(this.Period(value)); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Symbol
                #define Symbol DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol, 0)
                #undef MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Period
                #define Period DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period, 0)
                #undef MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
            // Function routers
        
                bool                dbg_mqlapi_trace_func_Symbol(string symbol)                     { return(__Symbol(symbol)); }
                bool                dbg_mqlapi_trace_func_Period(ENUM_TIMEFRAMES value)             { return(__Period(period)); }
        };

    #endif
    
    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CSERIES
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_Series_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Series_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_Series_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Series_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef Symbol
                #undef Symbol
                #define MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef Period
                #undef Period
                #define MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
                string              __Symbol() const                                                { return(this.Symbol()); }
                ENUM_TIMEFRAMES     __Period() const                                                { return(this.Period()); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Symbol
                #define Symbol DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol, 0)
                #undef MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Period
                #define Period DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Period, 0)
                #undef MQLAPI_TRACE_REDEFINE_Period
        
            #endif
        
        
            // Function routers
        
                string              dbg_mqlapi_trace_func_Symbol() const                            { return(__Symbol()); }
                ENUM_TIMEFRAMES     dbg_mqlapi_trace_func_Period() const                            { return(__Period()); }
        };

    #endif
    
    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_DealOrderPositionInfo_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_DealOrderPositionInfo_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_DealOrderPositionInfo_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_DealOrderPositionInfo_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef Symbol
                #undef Symbol
                #define MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef Comment
                #undef Comment
                #define MQLAPI_TRACE_REDEFINE_Comment
        
            #endif
        
        
                string              __Symbol() const                                                { return(this.Symbol()); }
                string              __Comment() const                                               { return(this.Comment()); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Symbol
                #define Symbol DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Symbol, 0)
                #undef MQLAPI_TRACE_REDEFINE_Symbol
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Comment
                #define Comment DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Comment, 0)
                #undef MQLAPI_TRACE_REDEFINE_Comment
        
            #endif
        
        
            // Function routers
        
                string              dbg_mqlapi_trace_func_Symbol() const                            { return(__Symbol()); }
                string              dbg_mqlapi_trace_func_Comment() const                           { return(__Comment()); }
        };

    #endif
    
    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_SymbolInfo_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_SymbolInfo_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_SymbolInfo_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_SymbolInfo_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef Digits
                #undef Digits
                #define MQLAPI_TRACE_REDEFINE_Digits
        
            #endif
            #ifdef Point
                #undef Point
                #define MQLAPI_TRACE_REDEFINE_Point
        
            #endif
        
        
                int                 __Digits() const                                                { return(this.Digits()); }
                double              __Point() const                                                 { return(this.Point()); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_Digits
                #define Digits DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Digits, 0)
                #undef MQLAPI_TRACE_REDEFINE_Digits
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_Point
                #define Point DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_Point, 0)
                #undef MQLAPI_TRACE_REDEFINE_Point
        
            #endif
        
        
            // Function routers
        
                int                 dbg_mqlapi_trace_func_Digits() const                            { return(__Digits()); }
                double              dbg_mqlapi_trace_func_Point() const                             { return(__Point()); }
        };

    #endif
    
    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CTRADE
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_Trade_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Trade_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_Trade_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Trade_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef OrderCheck
                #undef OrderCheck
                #define MQLAPI_TRACE_REDEFINE_OrderCheck
        
            #endif
            #ifdef OrderSend
                #undef OrderSend
                #define MQLAPI_TRACE_REDEFINE_OrderSend
        
            #endif
            #ifdef IsStopped
                #undef IsStopped
                #define MQLAPI_TRACE_REDEFINE_IsStopped
        
            #endif
        
        
                bool                __OrderCheck(const MqlTradeRequest &request, MqlTradeCheckResult &check_result)                         { return(this.OrderCheck(request, check_result)); }
                bool                __OrderSend(const MqlTradeRequest &request, MqlTradeResult &result)                                     { return(this.OrderSend(request, result)); }
                bool                __IsStopped(const string function)                                                                      { return(this.IsStopped(function)); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_OrderCheck
                #define OrderCheck DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderCheck, 0)
                #undef MQLAPI_TRACE_REDEFINE_OrderCheck
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_OrderSend
                #define OrderSend DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_OrderSend, 0)
                #undef MQLAPI_TRACE_REDEFINE_OrderSend
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_IsStopped
                #define IsStopped DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_IsStopped, 0)
                #undef MQLAPI_TRACE_REDEFINE_IsStopped
        
            #endif
        
        
            // Function routers
        
                bool                dbg_mqlapi_trace_func_OrderCheck(const MqlTradeRequest &request, MqlTradeCheckResult &check_result)     { return(__OrderCheck(request, check_result)); }
                bool                dbg_mqlapi_trace_func_OrderSend(const MqlTradeRequest &request, MqlTradeResult &result)                 { return(__OrderSend(request, result)); }
                bool                dbg_mqlapi_trace_func_IsStopped(const string function)                                                  { return(__IsStopped(function)); }
        };

    #endif
    
    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CFILE
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_File_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_File_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_File_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_File_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef FolderCreate
                #undef FolderCreate
                #define MQLAPI_TRACE_REDEFINE_FolderCreate
        
            #endif
            #ifdef FolderDelete
                #undef FolderDelete
                #define MQLAPI_TRACE_REDEFINE_FolderDelete
        
            #endif
            #ifdef FolderClean
                #undef FolderClean
                #define MQLAPI_TRACE_REDEFINE_FolderClean
        
            #endif
            #ifdef FileFindFirst
                #undef FileFindFirst
                #define MQLAPI_TRACE_REDEFINE_FileFindFirst
        
            #endif
            #ifdef FileFindNext
                #undef FileFindNext
                #define MQLAPI_TRACE_REDEFINE_FileFindNext
        
            #endif
            #ifdef FileFindClose
                #undef FileFindClose
                #define MQLAPI_TRACE_REDEFINE_FileFindClose
        
            #endif
        
        
                bool                __FolderCreate(const string folder_name)                                                                { return(this.FolderCreate(folder_name)); }
                bool                __FolderDelete(const string folder_name)                                                                { return(this.FolderDelete(folder_name)); }
                bool                __FolderClean(const string folder_name)                                                                 { return(this.FolderClean(folder_name)); }
                long                __FileFindFirst(const string file_filter, string &returned_filename)                                    { return(this.FileFindFirst(file_filter, returned_filename)); }
                bool                __FileFindNext(const long search_handle, string &returned_filename)                                     { return(this.FileFindNext(search_handle, returned_filename)); }
                void                __FileFindClose(const long search_handle)                                                               { this.FileFindClose(search_handle); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_FolderCreate
                #define FolderCreate DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderCreate, 0)
                #undef MQLAPI_TRACE_REDEFINE_FolderCreate
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_FolderDelete
                #define FolderDelete DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderDelete, 0)
                #undef MQLAPI_TRACE_REDEFINE_FolderDelete
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_FolderClean
                #define FolderClean DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FolderClean, 0)
                #undef MQLAPI_TRACE_REDEFINE_FolderClean
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_FileFindFirst
                #define FileFindFirst DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindFirst, 0)
                #undef MQLAPI_TRACE_REDEFINE_FileFindFirst
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_FileFindNext
                #define FileFindNext DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindNext, 0)
                #undef MQLAPI_TRACE_REDEFINE_FileFindNext
        
            #endif
            #ifdef MQLAPI_TRACE_REDEFINE_FileFindClose
                #define FileFindClose DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_FileFindClose, 0)
                #undef MQLAPI_TRACE_REDEFINE_FileFindClose
        
            #endif
        
        
            // Function routers
        
                bool                dbg_mqlapi_trace_func_FolderCreate(const string folder_name)                                            { return(__FolderCreate(folder_name)); }
                bool                dbg_mqlapi_trace_func_FolderDelete(const string folder_name)                                            { return(__FolderDelete(folder_name)); }
                bool                dbg_mqlapi_trace_func_FolderClean(const string folder_name)                                             { return(__FolderClean(folder_name)); }
                long                dbg_mqlapi_trace_func_FileFindFirst(const string file_filter, string &returned_filename)                { return(__FileFindFirst(file_filter, returned_filename)); }
                bool                dbg_mqlapi_trace_func_FileFindNext(const long search_handle, string &returned_filename)                 { return(__FileFindNext(search_handle, returned_filename)); }
                void                dbg_mqlapi_trace_func_FileFindClose(const long search_handle)                                           { __FileFindClose(search_handle); }
        };

    #endif

    
    #ifdef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
        template <typename MQL5_STDLIB>
        class stdlib_call_tracer_Canvas_mql5 : public stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Canvas_mql5<MQL5_STDLIB>>
        {
            public:
            // Constructor
        
                stdlib_call_tracer_Canvas_mql5() :
                    stdlib_call_tracer_mql5<MQL5_STDLIB, stdlib_call_tracer_Canvas_mql5<MQL5_STDLIB>>(::GetPointer(this))
                {};
        
        
            // Function router
            #ifdef TextOut
                #undef TextOut
                #define MQLAPI_TRACE_REDEFINE_TextOut
        
            #endif
        
        
                void                __TextOut(int x, int y, string text, const uint clr, uint alignment)                                    { this.TextOut(x, y, text, clr, alignment); }
        
        
            #ifdef MQLAPI_TRACE_REDEFINE_TextOut
                #define TextOut DBG_MSG_MQLFUNC(dbg_mqlapi_trace_func_TextOut, 0)
                #undef MQLAPI_TRACE_REDEFINE_TextOut
        
            #endif
        
        
            // Function routers
        
                void                dbg_mqlapi_trace_func_TextOut(int x, int y, string text, const uint clr, uint alignment = 0)            { __TextOut(x, y, text, clr, alignment); }
        };

    #endif

#ifndef __MQL4__
	};

#endif



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Global rewrite macros for standard library classes
//    

#ifdef LIB_MQLAPI_TRACE_STDLIB_CCHART
    #define CChart                  LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_Chart_mql5<CChart>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
    #define CChartObjectSubChart    LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_ChartObject_mql5<CChartObjectSubChart>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
    #define CTrailingMA             LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_TrailingMA_mql5<CTrailingMA>)
    #define CExpertBase             LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_ExpertBase_mql5<CExpertBase>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CSERIES
    #define CSeries                 LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_Series_mql5<CSeries>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CSERIES
    #define CDealInfo               LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_DealOrderPositionInfo_mql5<CDealInfo>)
    #define CHistoryOrderInfo       LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_DealOrderPositionInfo_mql5<CHistoryOrderInfo>)
    #define COrderInfo              LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_DealOrderPositionInfo_mql5<COrderInfo>)
    #define CPositionInfo           LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_DealOrderPositionInfo_mql5<CPositionInfo>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
    #define CSymbolInfo             LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_SymbolInfo_mql5<CSymbolInfo>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CTRADE
    #define CTrade                  LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_Trade_mql5<CTrade>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CFILE
    #define CFile                   LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_File_mql5<CFile>)

#endif
#ifdef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
    #define CCanvas                 LIB_DBG_NAMESPACE(dbg_lib, stdlib_call_tracer_Canvas_mql5<CCanvas>)

#endif



//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_STDLIB_MQL5_TRACER_MQH_INCLUDED
